#include <kikakubu.h>
#include <kyotsu.h>

#define DMA		(char*)0x0700
#define TOP		80
#define BOTTOM		143
#define LEFT		1
#define RIGHT		250
#define HAWKSHOT_MAX	4
#define KINGSHOT_MAX	5
#define PLAYER_MAX      2

typedef enum {
	menuTITLE  = 0,
	menuGAME   = 1,
} emenu;

emenu menu;

char credit;

typedef struct charastatus {
	unsigned char x,y;		//XvCg̕\ʒu
	unsigned char left,top;		//E̗]
	unsigned char width,height;	//E
	unsigned char visible;		//
} status;

const char bombx[]  = { 1,-1,-1, 1 };
const char bomby[]  = { 2, 2,-2,-2 };
const char kingxy[] = { -4,-2, -4,-2, -6,0, -4,2, -4,2 ,
			-4,-4, -6, 0, -3,0, -6,0, -4,4 };
const char kingno[] = { 0x12,0x13,0x14,0x15,
			0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,
			0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,
			0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,
			0x12,0x13,0x14,0x15,
			0x20,0x21,0x22,0x23,0x24,0x25,0x28,0x29,
			0x08,0x31,0x32,0x33,0x34,0x35,0x38,0x39,
			0x18,0x41,0x0e,0x43,0x0a,0x0b,0x48,0x49,
			0x12,0x13,0x14,0x15,
			0x20,0x21,0x22,0x23,0x24,0x25,0x2a,0x2b,
			0x09,0x31,0x32,0x33,0x34,0x35,0x3a,0x3b,
			0x19,0x41,0x0f,0x43,0x0c,0x0d,0x4a,0x4b };

status boss;
status bossxxx;
status bossweak;
status bossshot[KINGSHOT_MAX];
status hawk[PLAYER_MAX];
status hawkshot[PLAYER_MAX * HAWKSHOT_MAX];
status hawkbomb[PLAYER_MAX * HAWKSHOT_MAX];

char pause;
char counter;
char sprcnt;
char init;

//XvCg̃NA
void ClearSprite(char cnt)
{
	unsigned char i,first;
	for (i=cnt;i<64;i++) {
		if (i == 0) { first = 1; } else { first = 0; }
		//SetSprite(first, 0, 240, 0, 0);
		SetDMA( DMA, first, 0, 240, 0, 0);
	}
}

//ʂ̃NA
void ClearScreen()
{
	unsigned char x,y,pos[2];

	ClearSprite(0);
	for (y = 0; y < 30; y++)
	{
		for (x = 0; x < 32; x+=8)
		{
			GetBackgroundAddress(0, x, y, pos);
			VBlank();
			FillBackground(*(pos + 0), *(pos + 1), 0, 8);
			SetScroll( 0, 0 );
		}
	}
}

void DrawTitle(char first)
{
	unsigned char i,j;
	unsigned char bg[14];
	unsigned char pos[2];

	credit = 1;

	if (! first) {
		SetPPU(0x08,0x06);
		ClearScreen();
	}

	FillAttribute(0x23,0xc0,0xff,64);

	for (i = 0; i < 4; i++)
	{
		for (j = 0; j < 14; j++) { bg[j] = i * 16 + j + 2; }
		GetBackgroundAddress(0, 9, 6 + i, pos);
		SetBackground(*(pos + 0),*(pos + 1),(char *)bg,14);
	}
	SetScroll( 0, 0 );

	SetPPU(0x08,0x1e);
	menu = menuTITLE;

}

//ZbgmF
char Reset()
{
	if ( ButtonDown(0, BTN_START ) && ButtonPush(0, BTN_SELECT ) ) {
		DrawTitle(0);
		VBlank();
		SendDMA(0x7);
		pause = 0;
		init  = 0;
		return 1;
	} else {
		return 0;
	}
}

//ԈȂA^
//x肳邽߁A\ĂȂXvCgɃA^s
void HitAll()
{
	unsigned char i, j, p;
	unsigned char ax1, ay1, ax2, ay2, shot;
	unsigned char bx1[3], by1[3], bx2[3], by2[3];

	i = counter % HAWKSHOT_MAX;
	j = counter % KINGSHOT_MAX;

	for (p = 0; p < credit ; p++)
	{
		shot = p * HAWKSHOT_MAX + i;

		*(bx1 + 0) = boss.x     + bossweak.left;
		*(by1 + 0) = boss.y     + bossweak.top;
		*(bx2 + 0) = *(bx1 + 0) + bossweak.width;
		*(by2 + 0) = *(by1 + 0) + bossweak.height;

		*(bx1 + 1) = boss.x     + boss.left;
		*(by1 + 1) = boss.y     + boss.top;
		*(bx2 + 1) = *(bx1 + 1) + boss.width;
		*(by2 + 1) = *(by1 + 1) + boss.height;

		*(bx1 + 2) = boss.x     + bossxxx.left;
		*(by1 + 2) = boss.y     + bossxxx.top;
		*(bx2 + 2) = *(bx1 + 2) + bossxxx.width;
		*(by2 + 2) = *(by1 + 2) + bossxxx.height;

		ax1 = (hawkshot + shot)->x + (hawkshot + shot)->left;
		ay1 = (hawkshot + shot)->y + (hawkshot + shot)->top;
		ax2 = ax1 + (hawkshot + shot)->width;
		ay2 = ay1 + (hawkshot + shot)->height;

		if ( HitBox(ax1, ay1, ax2, ay2, *(bx1 + 0), *(by1 + 0), *(bx2 + 0), *(by2 + 0)) ) {
			if ((hawkshot + shot)->visible && bossweak.visible == 0) {
				bossweak.visible = 5;
			}
		}
		if ( HitBox(ax1, ay1, ax2, ay2, *(bx1 + 1), *(by1 + 1), *(bx2 + 1), *(by2 + 1)) ) {
			if ((hawkshot + shot)->visible) {
				(hawkshot + shot)->visible = 0;
			}
		}
		if ( HitBox(ax1, ay1, ax2, ay2, *(bx1 + 2), *(by1 + 2), *(bx2 + 2), *(by2 + 2)) ) {
			if ((hawkshot + shot)->visible && bossxxx.visible == 0) {
				(hawkshot + shot)->visible = 0;
				bossxxx.visible = 5;
			}
		}

		ax1 = (hawkbomb + shot)->x + (hawkbomb + shot)->left;
		ay1 = (hawkbomb + shot)->y + (hawkbomb + shot)->top;
		ax2 = ax1 + (hawkbomb + shot)->width;
		ay2 = ay1 + (hawkbomb + shot)->height;

		if ( HitBox(ax1, ay1, ax2, ay2, *(bx1 + 0), *(by1 + 0), *(bx2 + 0), *(by2 + 0)) ) {
			if ((hawkbomb + shot)->visible && bossweak.visible == 0) {
				bossweak.visible = 5;
			}
		}
		if ( HitBox(ax1, ay1, ax2, ay2, *(bx1 + 1), *(by1 + 1), *(bx2 + 1), *(by2 + 1)) ) {
			if ((hawkbomb + shot)->visible) {
				(hawkbomb + shot)->visible = 0;
			}
		}
		if ( HitBox(ax1, ay1, ax2, ay2, *(bx1 + 2), *(by1 + 2), *(bx2 + 2), *(by2 + 2)) ) {
			if ((hawkbomb + shot)->visible && bossxxx.visible == 0) {
				(hawkbomb + shot)->visible = 0;
				bossxxx.visible = 5;
			}
		}

		ax1 = (hawk + p)->x + (hawk + p)->left;
		ay1 = (hawk + p)->y + (hawk + p)->top;
		ax2 = ax1 + (hawk + p)->width;
		ay2 = ay1 + (hawk + p)->height;

		*(bx1 + 0) = (bossshot + j)->x + (bossshot + j)->left;
		*(by1 + 0) = (bossshot + j)->y + (bossshot + j)->top;
		*(bx2 + 0) = *(bx1 + 0) + (bossshot + j)->width;
		*(by2 + 0) = *(by1 + 0) + (bossshot + j)->height;

		if ( HitBox(ax1, ay1, ax2, ay2, *(bx1 + 0), *(by1 + 0), *(bx2 + 0), *(by2 + 0)) ) {
			if ((bossshot + j)->visible) {
				(bossshot + j)->visible = 0;
			}
		}
	}

}

void MoveKing()
{
	static unsigned char mode;
	char i, j, val, bosscnt, check[2];
	char no;

	if (init == 0) {
		mode = 0;
	}

	bosscnt = 0;
	no = counter % 3;

	if (no == 0) {
		if (mode == 0) {
			if (boss.x > LEFT + 9   ) { boss.x--; } else { mode = 2; }
			if (boss.y > TOP        ) { boss.y--; } else { mode = 1; }
		} else if (mode == 1) {
			if (boss.x > LEFT + 9   ) { boss.x--; } else { mode = 3; }
			if (boss.y < BOTTOM - 24) { boss.y++; } else { mode = 0; }
		} else if (mode == 2) {
			if (boss.x < RIGHT  - 60) { boss.x++; } else { mode = 0; }
			if (boss.y > TOP        ) { boss.y--; } else { mode = 3; }
		} else if (mode == 3) {
			if (boss.x < RIGHT  - 60) { boss.x++; } else { mode = 1; }
			if (boss.y < BOTTOM - 24) { boss.y++; } else { mode = 2; }
		}
	}

	for (i = 0; i < KINGSHOT_MAX; i++)
	{
		*(check + 1) = no;
		if (*(check + 1) == 2) { *(check + 1) = 0; }
		*(check + 1) = *(check + 1) * 10 + i * 2;
		*(check + 0) = (bossshot +i)->x + *(kingxy + *(check + 1));
		*(check + 1) = (bossshot +i)->y + *(kingxy + *(check + 1) + 1);
		if (! (bossshot +i)->visible ) {
			bosscnt++;
		} else if ( *(check + 0) < LEFT || *(check + 0) >= RIGHT || *(check + 1) < TOP + 1 || *(check + 1) > BOTTOM -1 ){
			(bossshot +i)->visible = 0;
		} else {
			(bossshot +i)->x = *(check + 0);
			(bossshot +i)->y = *(check + 1);
			SetDMA( DMA, 0, (bossshot +i)->x, (bossshot +i)->y, 4, 0x01);
			//SetSprite(0, (bossshot +i)->x, (bossshot +i)->y, 4, 0x01);
			sprcnt++;
		}
	}

	if (bosscnt == 5 && counter == 65) {
		for (i = 0; i < 5; i++)
		{
			(bossshot +i)->visible = 1;
			(bossshot +i)->x = boss.x;
			(bossshot +i)->y = boss.y + 16;
		}
	}

	if ( bossxxx.visible > 0) {
		bossxxx.visible--;
		SetDMA( DMA, 0, boss.x + 24, boss.y, 5 + bossxxx.visible  % 2, 0x02);
		//SetSprite( 0, boss.x + 24, boss.y, 5 + bossxxx.visible  % 2, 0x02);
		sprcnt++;
	}

	if ( bossweak.visible > 0) {
		bossweak.visible--;
		SetDMA( DMA, 0, boss.x, boss.y + 16, 5 + bossweak.visible % 2, 0x02);
		//SetSprite( 0, boss.x, boss.y + 16, 5 + bossweak.visible % 2, 0x02);
		sprcnt++;
	}

	if (counter < 75 && counter >= 50) {
		no = 56;
	} else if (counter >=  25) {
		no = 28;
	} else {
		no = 0;
	}

	for (i = 0; i < 4; i++)
	{
		for (j = 0 ; j < 8; j++)
		{
			if ((i == 0 && j >= 2 && j <= 5) || i > 0){
				if ((boss.y < TOP + 8  && i == 0) || (boss.y > BOTTOM - 32 && i == 3)) {
					val = 0x20;  //wƕ̃XvCgǂ̌ɕ\
				} else {
					val = 0x00;
				}
				SetDMA( DMA, 0, boss.x + j * 8, boss.y + i * 8, *(kingno + no), val);
				//SetSprite( 0, boss.x + j * 8, boss.y + i * 8, *(kingno + no), val);
				sprcnt++;
				no++;
			}
		}
	}
}

void MoveHawk()
{
	char i, j, flg, no, attack;
	char cnt, p, q;

	cnt = counter % 3;

	for (i = 0; i < credit; i++)
	{
		attack = 0;
		if ( ButtonDown(i, BTN_UP   ) && (hawk + i)->y > TOP    ) { (hawk + i)->y--; }
		if ( ButtonDown(i, BTN_DOWN ) && (hawk + i)->y < BOTTOM ) { (hawk + i)->y++; }
		if ( ButtonDown(i, BTN_RIGHT) && (hawk + i)->x < RIGHT  ) { (hawk + i)->x++; }
		if ( ButtonDown(i, BTN_LEFT ) && (hawk + i)->x > LEFT   ) { (hawk + i)->x--; }
		if ( ButtonPush(i, BTN_B    ) ) { attack = 2; }

		p   = i * HAWKSHOT_MAX;
		no  = 1;
		flg = i ^ 1;
		if (cnt == 0) {
			no  = 7;
			flg = 2;
		}
		if ((hawk + i)->y < TOP + 8 || (hawk + i)->y > BOTTOM - 8) { flg += 0x20; }
		SetDMA( DMA, 0, (hawk + i)->x, (hawk + i)->y, no, flg);
		//SetSprite( 0, (hawk + i)->x, (hawk + i)->y, no, flg);
		sprcnt++;

		for (j = 0; j < HAWKSHOT_MAX; j++)
		{
			q = p + j;
			if ( (hawkshot + q)->visible ) {
				(hawkshot + q)->x += 3;
				if ((hawkshot + q)->x < RIGHT && (hawkshot + q)->x > LEFT) {
					SetDMA( DMA, 0, (hawkshot + q)->x, (hawkshot + q)->y, 2, 0x01);
					//SetSprite( 0, (hawkshot + q)->x, (hawkshot + q)->y, 2, 0x01);
					sprcnt++;
				} else {
					(hawkshot + q)->visible = 0;
				}
			} else if (attack == 2){
				(hawkshot + q)->x = (hawk + i)->x;
				(hawkshot + q)->y = (hawk + i)->y;
				(hawkshot + q)->visible = 1;
				attack=1;
			}

			if ( (hawkbomb + q)->visible ) {
				(hawkbomb + q)->x += *(bombx + j) * cnt;
				(hawkbomb + q)->y += *(bomby + j);
				if ((hawkbomb + q)->x < RIGHT && (hawkbomb + q)->x > LEFT && (hawkbomb + q)->y < BOTTOM && (hawkbomb + q)->y > TOP) {
					flg = 0x01;
					if (j == 1 || j == 3) { flg += 0x40; }
					SetDMA( DMA, 0, (hawkbomb + q)->x, (hawkbomb + q)->y, 3, flg);
					//SetSprite( 0, (hawkbomb + q)->x, (hawkbomb + q)->y, 3, flg);
					sprcnt++;
				} else {
					(hawkbomb + q)->visible = 0;
				}
			} else if (attack > 0){
				(hawkbomb + q)->x = (hawk + i)->x;
				(hawkbomb + q)->y = (hawk + i)->y;
				(hawkbomb + q)->visible = 1;
			}
		}

	}
}

void Game()
{
	static unsigned char bgx;
	static unsigned char cnt;

	if ( Reset() ) { return; }
	if ( ButtonPush( 0, BTN_START ) ) { pause ^= 1; }
	if ( pause   ) { return; }

	if (init == 0) {
		bgx = 0;
		cnt = 0;
		bossxxx.visible = 0;
		bossweak.visible = 0;
	}

	SetDMA( DMA, 1, 124, TOP - 4, 16, 3);
	//SetSprite( 1, 124, TOP - 4, 16, 3);
	sprcnt=1;

	SetScroll(bgx, 0);

	MoveHawk();
	MoveKing();
	HitAll();
	ClearSprite(sprcnt);

	VBlank();
	SendDMA(0x7);

	counter++;
	if (counter == 100) { counter = 0; }

	bgx++;
	init = 1;
}

void Title()
{
	unsigned char i, j, bg[8], pos[2];

	if ( ButtonPush(0, BTN_SELECT) ) {
		if (credit == 1) { credit = 2; } else { credit = 1; }
	}

	VBlank();
	if (credit == 1) {
		SetBackground(0x22,0x8b,"ONE PLAYER ", 11);
	} else {
		SetBackground(0x22,0x8b,"TWO PLAYERS", 11);
	}
	SetScroll( 0, 0 );

	if ( ButtonPush(0, BTN_START) || ButtonPush(0, BTN_A) ) {
		SetPPU(0x08,0x06);

		//^Cg
		ClearScreen();

		//wiFݒ
		FillAttribute(0x23,0xd0,0xa5,8);
		FillAttribute(0x23,0xd8,0x55,8);
		FillAttribute(0x23,0xe0,0xa5,8);

		//wi`iij
		for (i = 0; i < 8; i++) { *(bg + i) = 0x80 + i; }
		for (i = 0; i < 2; i++) {
			GetBackgroundAddress(0, i * 16, 10, pos);
			SetBackground(*(pos + 0),*(pos + 1),bg,8);
		}

		for (i = 0; i < 8; i++) { *(bg + i) = 0x90 + i; }
		for (i = 0; i < 2; i++) {
			GetBackgroundAddress(0, i * 16 + 8, 10, pos);
			SetBackground(*(pos + 0),*(pos + 1),bg,8);
		}

		//wi`iij
		for (i = 0; i < 5; i++) { 
			for (j = 0; j < 5; j++) { *(bg + j) = 0x88 + i * 0x10 + j; }
			for (j = 0; j < 6; j++) {
				GetBackgroundAddress(0, j * 5, 12 + i, pos);
				SetBackground(*(pos + 0),*(pos + 1),bg,5);
			}
			GetBackgroundAddress(0, 30, 12 + i, pos);
			SetBackground(*(pos + 0),*(pos + 1),bg,2);
		}

		//wi`iiEQj
		for (i = 0; i < 5; i++) { 
			for (j = 0; j < 3; j++) { *(bg + j) = 0x8d + i * 0x10 + j; }
			GetBackgroundAddress(0, 5, 12 + i, pos);
			SetBackground(*(pos + 0),*(pos + 1),bg,3);

			GetBackgroundAddress(0, 9, 12 + i, pos);
			SetBackground(*(pos + 0),*(pos + 1),bg,3);

			GetBackgroundAddress(0,16, 12 + i, pos);
			SetBackground(*(pos + 0),*(pos + 1),bg,3);
		}

		//wi`iij
		for (i = 0; i < 8; i++) { *(bg + i) = 0xa0 + i; }
		for (i = 0; i < 2; i++) {
			GetBackgroundAddress(0, i * 16, 18, pos);
			SetBackground(*(pos + 0),*(pos + 1),bg,8);
		}

		for (i = 0; i < 8; i++) { *(bg + i) = 0xb0 + i; }
		for (i = 0; i < 2; i++) {
			GetBackgroundAddress(0, i * 16 + 8, 18, pos);
			SetBackground(*(pos + 0),*(pos + 1),bg,8);
		}

		//Lݒ
		for (i = 0; i < 2; i++) {
			(hawk + i)->x=80;
			(hawk + i)->y=120 + i * 20;
			(hawk + i)->top=1+1;
			(hawk + i)->left=0+1;
			//(hawk + i)->width=8-1;
			(hawk + i)->width=16;
			(hawk + i)->height=5-1;
		}

		boss.x=140;
		boss.y=100;
		boss.top=8;
		boss.left=0;
		boss.width=64;

		boss.height=24;
		bossxxx.top=0;
		bossxxx.left=25;
		bossxxx.width=25;
		bossxxx.height=8;

		bossweak.top=16;
		bossweak.left=0;
		bossweak.width=4;
		bossweak.height=8;

		for (i = 0; i < 2; i++)
		{
			for (j = 0; j < HAWKSHOT_MAX; j++)
			{
				(hawkshot + i * HAWKSHOT_MAX + j)->top     = 1;
				(hawkshot + i * HAWKSHOT_MAX + j)->left    = 2;
				//(hawkshot + i * HAWKSHOT_MAX + j)->width = 4;
				(hawkshot + i * HAWKSHOT_MAX + j)->width   =16;
				(hawkshot + i * HAWKSHOT_MAX + j)->height  = 5;
				(hawkshot + i * HAWKSHOT_MAX + j)->visible = 0;
			}
		}

		for (i = 0; i < 2; i++)
		{
			for (j = 0; j < HAWKSHOT_MAX; j++)
			{
				(hawkbomb + i * HAWKSHOT_MAX + j)->top     = 2;
				(hawkbomb + i * HAWKSHOT_MAX + j)->left    = 2;
				(hawkbomb + i * HAWKSHOT_MAX + j)->width   = 2;
				(hawkbomb + i * HAWKSHOT_MAX + j)->height  = 2;
				(hawkbomb + i * HAWKSHOT_MAX + j)->visible = 0;
			}
		}

		for (i = 0; i < KINGSHOT_MAX; i++)
		{
			//(bossshot +i)->top   = 2;
			//(bossshot +i)->left  = 2;
			//(bossshot +i)->width = 4;
			//(bossshot +i)->height= 4;
			(bossshot +i)->top     =  0;
			(bossshot +i)->left    =  0;
			(bossshot +i)->width   = 16;
			(bossshot +i)->height  =  8;
			(bossshot +i)->visible =  0;
		}

		SetPPU(0x08,0x1e);
		counter = 0;
		menu = menuGAME;
	}
}

// C
void NesMain()
{
/*
	const char palettebg[] = {
		0x0f, 0x11, 0x21, 0x30, 0x0f, 0x27, 0x36, 0x20, 0x0f, 0x16, 0x26, 0x20, 0x0f, 0x21, 0x31, 0x30
	};
	const char palettespr[] = {
		0x0f, 0x11, 0x21, 0x30, 0x0f, 0x15, 0x00, 0x30, 0x0f, 0x15, 0x27, 0x29, 0x0f, 0x38, 0x0f, 0x30
	};
*/
	const char palettebg[] = {
		0x0f, 0x11, 0x21, 0x30,
		0x0f, 0x0f, 0x07, 0x17,		//wi
		0x0f, 0x07, 0x17, 0x26,		//㉺
		0x0f, 0x21, 0x31, 0x30
	};
	const char palettespr[] = {
		0x0f, 0x02, 0x11, 0x10,		//{X
		0x0f, 0x15, 0x00, 0x30,
		0x0f, 0x15, 0x27, 0x29,
		0x0f, 0x38, 0x0f, 0x30
	};

	//ZONE A][0F 07 17:wi] [07 17 26:㉺] [02 11 10:KING  FOSSIL-A]
	//ZONE B][04 17 27:wi] [07 17 26:㉺] [04 13 10:ELECTRIC FAN-B]
	//ZONE C][0C 1B 2B:wi] [07 17 26:㉺] [05 16 10:ELECTRIC FAN-C]

	VBlank();
	InitPPU();

	pause   = 0;
	counter = 0;
	init    = 0;

	// pbgݒ
	SetPalette((char *)palettebg ,0);
	SetPalette((char *)palettespr,1);

	DrawTitle(1);

	while (1) {
		CheckPad();
		switch (menu) {
		case menuTITLE:
			Title();
			break;
		case menuGAME:
			Game();
			break;
		}
	}
}

//NMI荞
void NMIProc(void){}
